
addHook("PlayerThink", function(player)
	if (player.crosscodehudinfo == nil or player.crosscodehudscore == nil)
	player.crosscodehudinfo = true
	player.crosscodehudscore = true
	player.crosscodehudtime = true
	
	player.disablecrosscodehudinfo = false
	player.disablecrosscodehudscore = false
	player.disablecrosscodehudtime = false
	end
	
	if (player.disablecrosscodehudinfo == true)
	player.disablecrosscodehudinfo = false
	end
	
	if (player.disablecrosscodehudscore == true)
	player.disablecrosscodehudscore = false
	end
	
	if (player.disablecrosscodehudtime == true)
	player.disablecrosscodehudtime = false
	end
	
	if (player.disablecrosscodehudinfo == true)
	player.crosscodehudinfo = false
	else
	player.crosscodehudinfo = true
	end
	
	if (player.disablecrosscodehudscore == true)
	player.crosscodehudscore = false
	else
	player.crosscodehudscore = true
	end
	
	if (player.disablecrosscodehudtime == true)
	player.crosscodehudtime = false
	else
	player.crosscodehudtime = true
	end
	
	if (player.mo.skin == "modernsonic")
	and (player.hudstyle ~= "srb2")
	CrossCodeHudDisable("info", player)
	CrossCodeHudDisable("score", player)
	CrossCodeHudDisable("time", player)
	end
	
	if (player.hypermysticsonic)
	CrossCodeHudDisable("info", player)
	CrossCodeHudDisable("score", player)
	CrossCodeHudDisable("time", player)
	end
	
	if (player.mrce)
	CrossCodeHudDisable("info", player)
	CrossCodeHudDisable("score", player)
	CrossCodeHudDisable("time", player)
	end
end)

rawset(_G, "CrossCodeHudDisable", function(string, player)
	if (player == nil)
	print("\x82"+"WARNING: the CrossCodeHudDisable function got a nil player")
	return end
	if (string == "info")
	player.disablecrosscodehudinfo = true
	end
	if (string == "score")
	player.disablecrosscodehudscore = true
	end
	if (string == "time")
	player.disablecrosscodehudtime = true
	end
end)

local function cchud(v, player)
		local rings = player.rings
		local score = player.score
		local time = player.realtime
		local hudringdist = 45
		local flags = V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER
		if (hud.enabled("score") or hud.enabled("rings") or hud.enabled("lives") and not player.hypermysticsonic)
		hud.disable("score")
		hud.disable("rings")
		hud.disable("time")
		end
			if (rings >= 10 and rings < 100)
			hudringdist = 50
			elseif (rings >= 100 and rings < 1000)
			hudringdist = 55
			elseif (rings >= 1000)
			hudringdist = 60
			elseif (rings < 10)
			hudringdist = 45
			end
				
				if (player.crosscodehudinfo == true)
					if not (player.charflags & SF_SUPER) 
					v.drawScaled(16*FRACUNIT, 10*FRACUNIT, 3*FRACUNIT/2, v.cachePatch("CCHUDRING"), flags)
					elseif (player.charflags & SF_SUPER)
					v.drawScaled(16*FRACUNIT, 10*FRACUNIT, 3*FRACUNIT/2, v.cachePatch("CCHUDEMERALD"), flags)
					end
					v.drawNum(hudringdist, 30, rings, flags)
				end
					
				if (player.crosscodehudscore == true)
				v.drawScaled(50*FRACUNIT, 10*FRACUNIT, 5*FRACUNIT/4, v.cachePatch("CCHUDSCORE"), flags)
				v.drawNum(125, 18, score, flags)
				end
					
				if (player.crosscodehudtime == true)
				v.drawScaled(123*FRACUNIT, 10*FRACUNIT, 5*FRACUNIT/4, v.cachePatch("CCHUDTIME"), flags)
				v.drawNum(160, 9, G_TicsToHours(player.realtime), flags)
				v.drawNum(180, 9, G_TicsToMinutes(player.realtime), flags)
				v.drawNum(200, 9, G_TicsToSeconds(player.realtime), flags)
				v.drawString(162, 9, ":", flags)
				v.drawString(180, 9, ":", flags)
				end
	end
	hud.add(cchud, "game")